/*
								+--------------------------------+
								|                                |
								|   ***  Exact arithmetic  ***   |
								|                                |
								|  Copyright  -tHE SWINe- 2014  |
								|                                |
								|           Exact.cpp            |
								|                                |
								+--------------------------------+
*/

/**
 *	@file Exact.cpp
 *	@author -tHE SWINe-
 *	@date 2014
 *	@brief exact multi-precision floating-point arithmetic
 */

#include "NewFix.h"
#include "Exact.h"

namespace expansion {

const expansion_internal::TFromScalar_Tag from_scalar;
const expansion_internal::TFromScalar_ZeroPad_Tag from_scalar_zero_pad;
const expansion_internal::TFromArray_Tag from_array;
const expansion_internal::TFromArray_ZeroPad_Tag from_array_zero_pad;
const expansion_internal::TFromTwoSum_Tag from_sum_of_scalars;
const expansion_internal::TFromTwoDiff_Tag from_difference_of_scalars;
const expansion_internal::TFromTwoProd_Tag from_product_of_scalars;
const expansion_internal::TFromScalarSquare_Tag from_square_of_scalar;
// keep the types in expansion_internal to have expansion as empty as possible

} // ~expansion

namespace expansion_internal {

const TUninitializedConstruct_Tag uninitialized_construct;

} // ~expansion_internal
